unit VirtualListBoxMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls;

type
  TfrmVirtualListBox = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    StatusBar1: TStatusBar;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Data(Control: TWinControl; Index: Integer; var Data: string);
    function ListBox1DataFind(Control: TWinControl; FindString: string): Integer;
  private
    FList: TStringList;
    procedure Time(addToListBox: TProc);
  public
  end;

var
  frmVirtualListBox: TfrmVirtualListBox;

implementation

uses
  System.Diagnostics;

{$R *.dfm}

const
  CNumLines = 10000;

procedure TfrmVirtualListBox.FormCreate(Sender: TObject);
begin
  FList := TStringList.Create;
end;

procedure TfrmVirtualListBox.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FList);
end;

procedure TfrmVirtualListBox.Button1Click(Sender: TObject);
begin
  Time(
    procedure
    var
      i: integer;
    begin
      FList.Capacity := CNumLines;
      for i := 1 to CNumLines do
        FList.Add('Line ' + IntToStr(i));

      ListBox1.Count := CNumLines;
    end
  );
end;

procedure TfrmVirtualListBox.ListBox1Data(Control: TWinControl; Index: Integer;
    var Data: string);
begin
  Data := FList[Index];
end;

function TfrmVirtualListBox.ListBox1DataFind(Control: TWinControl;
  FindString: string): Integer;
begin
  Result := FList.IndexOf(FindString);
end;

procedure TfrmVirtualListBox.Time(addToListBox: TProc);
var
  stopwatch: TStopwatch;
begin
  ListBox1.Clear;

  stopwatch := TStopwatch.StartNew;

  addToListBox();

  stopwatch.Stop;

  StatusBar1.SimpleText := Format('ListBox: %d ms', [stopwatch.ElapsedMilliseconds]);
end;

end.
